AppdefBossEJBImpl (Hyperic HQ Plugin API)
Keywords: org.hyperic.hq.bizapp.server.session.AppdefBossEJBImpl class

Overview | Package | Class | Tree | Deprecated | Index | Help
| Hyperic HQ Plugin API v. 4.4.0.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hyperic.hq.bizapp.server.session
Class AppdefBossEJBImpl

    java.lang.Object
      org.hyperic.hq.bizapp.server.session.BizappSessionEJB
          org.hyperic.hq.bizapp.server.session.AppdefBossEJBImpl

All Implemented Interfaces:
  java.io.Serializable, javax.ejb.EnterpriseBean, javax.ejb.SessionBean

    public class AppdefBossEJBImpl

extends BizappSessionEJB
implements javax.ejb.SessionBean

See Also:
  Serialized Form

Field Summary
`protected int` | `APPDEF_GROUP_TYPE_UNDEFINED`
`protected int` | `APPDEF_RES_TYPE_UNDEFINED`
`protected int` | `APPDEF_TYPE_UNDEFINED`
`protected boolean` | `debug`
`protected org.apache.commons.logging.Log` | `log`

Fields inherited from class org.hyperic.hq.bizapp.server.session.BizappSessionEJB
`ctx`

Constructor Summary
`AppdefBossEJBImpl()`

Method Summary
`void` | `_removeApplicationInNewTran(AuthzSubject subject, Application app)`
`void` | `_removeGroupInNewTran(AuthzSubject subject, ResourceGroup group)`
`void` | `_removePlatformInNewTran(AuthzSubject subject, Platform platform)`
`void` | `_removeServerInNewTran(AuthzSubject subject, Server server)` Used only during the asynchronous delete process.
`void` | `_removeServiceInNewTran(AuthzSubject subject, Service service)` Used only during the asynchronous delete process.
`void` | `addResourcesToGroup(int sessionID, ResourceGroup group, java.util.List aeids)` Add entities to a resource group
`void` | `batchGroupAdd(int sessionId, AppdefEntityID entityId, java.lang.Integer[] groupIds)` Add an appdef entity to a batch of groups.
`void` | `batchGroupRemove(int sessionId, AppdefEntityID entityId, java.lang.Integer[] groupIds)` Remove an appdef entity from a batch of groups.
`AppdefResourceValue` | `changeResourceOwner(int sessionId, AppdefEntityID eid, java.lang.Integer newOwnerId)`
`ApplicationValue` | `createApplication(int sessionID, ApplicationValue appVal, java.util.Collection services, ConfigResponse protoProps)` Create an application
`ResourceGroup` | `createGroup(int sessionId, int adType, int adResType, java.lang.String name, java.lang.String description, java.lang.String location, java.lang.String[] resources, boolean privGrp)` Create and return a new compatible group type object.
`ResourceGroup` | `createGroup(int sessionId, int adType, java.lang.String name, java.lang.String description, java.lang.String location, java.lang.String[] resources, boolean privGrp)` Create and return a new strict mixed group value object.
`ResourceGroup` | `createGroup(int sessionId, java.lang.String name, java.lang.String description, java.lang.String location, java.lang.String[] resources, boolean privGrp)` Create and return a new mixed group value object.
`Platform` | `createPlatform(int sessionID, PlatformValue platformVal, java.lang.Integer platTypePK, java.lang.Integer agent)`
`ServerValue` | `createServer(int sessionID, ServerValue serverVal, java.lang.Integer platformPK, java.lang.Integer serverTypePK, java.util.Map cProps)` Create a server with CProps
`Service` | `createService(AuthzSubject subject, ServiceValue serviceVal, java.lang.Integer serviceTypePK, java.lang.Integer serverPK, java.util.Map cProps)` Create a service with CProps
`ServiceValue` | `createService(int sessionID, ServiceValue serviceVal, java.lang.Integer serviceTypePK, AppdefEntityID aeid)`
`void` | `ejbActivate()`
`void` | `ejbCreate()`
`void` | `ejbPassivate()`
`void` | `ejbRemove()`
`Agent` | `findAgentByIpAndPort(int sessionId, java.lang.String ip, int port)` Get the value of one agent based on the IP and Port on which the agent is listening
`java.util.List` | `findAllAgents(int sessionId)`
`java.util.List` | `findAllApplicationTypes(int sessionID)`
`java.util.Collection` | `findAllGroupPojos(int sessionId)` Produce list of all group pojos where caller is authorized
`PageList` | `findAllGroupsMemberExclusive(int sessionId, PageControl pc, AppdefEntityID entity)` Produce list of all groups where caller is authorized to modify.
`PageList` | `findAllGroupsMemberExclusive(int sessionId, PageControl pc, AppdefEntityID[] entities)` Produce list of all groups where caller is authorized to modify.
`PageList` | `findAllGroupsMemberExclusive(int sessionId, PageControl pc, AppdefEntityID entity, java.lang.Integer[] removeIds)` Produce list of all groups where caller is authorized to modify.
`PageList` | `findAllGroupsMemberExclusive(int sessionId, PageControl pc, AppdefEntityID entity, java.lang.Integer[] removeIds, Resource resourceType)` Produce list of all groups where caller is authorized to modify.
`PageList` | `findAllGroupsMemberInclusive(int sessionId, PageControl pc, AppdefEntityID entity)` Produce list of all groups where caller is authorized to modify.
`PageList` | `findAllPlatforms(int sessionID, PageControl pc)` Get all platforms in the inventory.
`PageList` | `findAllPlatformTypes(int sessionID, PageControl pc)` Find all the platform types defined in the system.
`PageList` | `findAllResourceTypes(int sessionId, int entType, PageControl pc)`
`PageList` | `findAllResourceTypes(int sessionId, PageControl pc)`
`PageList` | `findAllServerTypes(int sessionID, PageControl pc)` Find all the server types defined in the system.
`PageList` | `findAllServiceTypes(int sessionID, PageControl pc)`
`ApplicationValue` | `findApplicationById(int sessionID, java.lang.Integer id)`
`PageList` | `findApplications(int sessionID, AppdefEntityID id, PageControl pc)`
`ApplicationType` | `findApplicationTypeById(int sessionId, java.lang.Integer id)`
`PageList` | `findAvailableServicesForApplication(int sessionId, java.lang.Integer appId, AppdefEntityID[] pendingEntities, java.lang.String nameFilter, PageControl pc)` Find SERVICE compatible inventory.
`AppdefResourceValue` | `findById(int sessionId, AppdefEntityID entityId)` Looks up and returns a value object corresponding to the appdef entity represented by the instance id passed in.
`PageList` | `findByIds(int sessionId, AppdefEntityID[] entities, PageControl pc)` Looks up and returns a list of value objects corresponding to the list of appdef entity represented by the instance ids passed in.
`PageList` | `findChildResources(int sessionID, AppdefEntityID parent, AppdefEntityTypeID childResourceType, PageControl pc)` Get first-level child resources of a given resource based on the child resource type.
`AppdefResourceType` | `findCommonResourceType(int sessionID, java.lang.String[] aeids)` Find a common appdef resource type among the appdef entities
`PageList` | `findCompatInventory(int sessionId, int appdefTypeId, int appdefResTypeId, AppdefEntityID groupEntity, AppdefEntityID[] pendingEntities, java.lang.String resourceName, PageControl pc)` Produce list of compatible, viewable inventory items.
`PageList` | `findCompatInventory(int sessionId, int groupType, int appdefTypeId, int groupEntTypeId, int appdefResTypeId, java.lang.String resourceName, AppdefEntityID[] pendingEntities, PageControl pc)` Produce list of compatible, viewable inventory items.
`AppdefGroupValue` | `findGroup(int sessionId, java.lang.Integer id)`
`ResourceGroup` | `findGroupById(int sessionId, java.lang.Integer groupId)`
`PageList` | `findGroups(int sessionId, java.lang.Integer[] groupIds, PageControl pc)` Lookup and return a list of group value objects by their identifiers.
`PlatformValue` | `findPlatformByDependentID(int sessionID, AppdefEntityID entityId)` Find the platform by service.
`PlatformValue` | `findPlatformById(int sessionID, java.lang.Integer id)`
`PageList` | `findPlatformServices(int sessionID, java.lang.Integer platformId, java.lang.Integer typeId, PageControl pc)`
`PageList` | `findPlatformServices(int sessionID, java.lang.Integer platformId, PageControl pc)`
`PlatformType` | `findPlatformTypeById(int sessionID, java.lang.Integer id)`
`PlatformType` | `findPlatformTypeByName(int sessionID, java.lang.String name)`
`PageList` | `findRecentPlatforms(int sessionID, long range, int size)` Get recently created platforms in the inventory.
`Agent` | `findResourceAgent(AppdefEntityID entityId)`
`AppdefResourceTypeValue` | `findResourceTypeById(int sessionID, AppdefEntityTypeID id)`
`ServerValue` | `findServerById(int sessionID, java.lang.Integer id)`
`ServerValue` | `findServerByService(int sessionID, java.lang.Integer serviceID)`
`PageList` | `findServersByPlatform(int sessionID, java.lang.Integer platformId, PageControl pc)` Find all servers on a given platform
`PageList` | `findServersByTypeAndPlatform(int sessionId, java.lang.Integer platformId, int adResTypeId, PageControl pc)`
`ServerType` | `findServerTypeById(int sessionID, java.lang.Integer id)`
`PageList` | `findServerTypesByPlatform(int sessionID, java.lang.Integer platformId, PageControl pc)`
`PageList` | `findServerTypesByPlatformType(int sessionID, java.lang.Integer platformId, PageControl pc)`
`ServiceValue` | `findServiceById(int sessionID, java.lang.Integer id)`
`PageList` | `findServiceInventoryByApplication(int sessionID, java.lang.Integer appId, PageControl pc)` Find service inventory by application - including services and clusters
`PageList` | `findServicesByServer(int sessionID, java.lang.Integer serverId, PageControl pc)` Find all services on a server
`ServiceType` | `findServiceTypeById(int sessionID, java.lang.Integer id)`
`PageList` | `findServiceTypesByServerType(int sessionID, int serverTypeId)`
`PageList` | `findViewablePlatformServiceTypes(int sessionID, java.lang.Integer platId)`
`PageList` | `findViewablePlatformTypes(int sessionID, PageControl pc)` Find all the viewable platform types defined in the system.
`PageList` | `findViewableServersByPlatform(int sessionID, java.lang.Integer platformId, PageControl pc)` Get the virtual servers for a given platform
`PageList` | `findViewableServerTypes(int sessionID, PageControl pc)` Find all viewable server types defined in the system.
`PageList` | `findViewableServiceTypes(int sessionID, PageControl pc)`
`ServerValue` | `findVirtualServerByPlatformServiceType(int sessionID, java.lang.Integer platId, java.lang.Integer svcTypeId)` Get the virtual server for a given platform and service type
`int` | `getAgentCount(int sessionId)`
`java.lang.String[][]` | `getAppdefTypeStrArrMap()` Returns a 2x2 array mapping "appdef type id" to its corresponding label.
`DependencyTree` | `getAppDependencyTree(int sessionId, java.lang.Integer appId)` Get the dependency tree for a given application
`java.util.Properties` | `getCPropDescEntries(int sessionId, AppdefEntityID id)` Get a map which holds the descriptions & their associated values for an appdef entity.
`java.util.List` | `getCPropKeys(int sessionId, AppdefEntityID aeid)` Get all the keys associated with an appdef type of a resource.
`java.util.List` | `getCPropKeys(int sessionId, int appdefType, int appdefTypeId)` Get all the keys associated with an appdef resource type.
`java.util.Collection` | `getGroupsForResource(int sessionId, Resource r)`
`AppdefInventorySummary` | `getInventorySummary(int sessionId, boolean countTypes)` Get the appdef inventory summary visible to a user
`ResourceTreeNode[]` | `getNavMapData(int sessionId, AppdefEntityID adeId)` Get the navigation map data for a given Appdef entity.
`ResourceTreeNode[]` | `getNavMapData(int sessionId, AppdefEntityID[] adeIds, int ctype)` Get the navigation map data for a an auto-group.
`static org.hyperic.hq.bizapp.shared.AppdefBossLocal` | `getOne()`
`AppdefResourcePermissions` | `getResourcePermissions(int sessionId, AppdefEntityID id)`
`java.util.Map` | `getResourceTypeCountMap(int sessionId, java.lang.Integer groupId)`
`java.util.List` | `getServicesView(AuthzSubject subject, Resource proto, java.lang.String cprop, java.lang.String metricName, PageInfo pi)` Get Service resources and their display information
`java.util.Collection` | `getUnavailableResources(AuthzSubject user, java.lang.String typeId, PageInfo info)` Get the list of resources that are unavailable
`java.util.Map` | `getUnavailableResourcesCount(AuthzSubject user)` Get the map of unavailable resource counts by type
`boolean` | `hasVirtualResourceRelation(Resource resource)` Check whether or not a given resource exists in the virtual hierarchy
`AppdefEntityID[]` | `removeAppdefEntity(int sessionId, AppdefEntityID aeid)` Removes an appdef entity by nulling out any reference from its children and then deleting it synchronously.
`void` | `removeAppService(int sessionId, java.lang.Integer appId, java.lang.Integer serviceId)` Remove an application service.
`void` | `removeDeletedResources(java.util.Map agentCache)` Remove all delete resources Method is "NotSupported" since all the resource deletes may take longer than the jboss transaction timeout.
`void` | `removePlatform(AuthzSubject subject, Platform platform)`
`void` | `removeResourcesFromGroup(int sessionId, ResourceGroup group, java.util.Collection resources)` Remove resources from the group's contents.
`void` | `removeServer(AuthzSubject subj, java.lang.Integer serverId)`
`void` | `resetResourceOwnership(int sessionId, AuthzSubject currentOwner)` Update all the appdef resources owned by this user to be owned by the root user.
`PageList` | `search(int sessionId, int appdefTypeId, java.lang.String searchFor, AppdefEntityTypeID appdefResType, java.lang.Integer groupId, int[] groupSubType, boolean matchAny, boolean matchOwn, boolean matchUnavail, PageControl pc)` Perform a search for resources from the resource hub
`PageList` | `search(int sessionId, java.lang.String searchFor, PageControl pc)` Perform a search for resources
`void` | `setAllConfigResponses(int sessionInt, AllConfigResponses allConfigs, AllConfigResponses allConfigsRollback)` A method to set ALL the configs of a resource.
`void` | `setAppDependencyTree(int sessionId, DependencyTree depTree)`
`void` | `setApplicationServices(int sessionId, java.lang.Integer appId, java.util.List entityIds)` Set the services used by an application indicate whether the service is an entry point
`void` | `setCPropValue(int sessionId, AppdefEntityID id, java.lang.String key, java.lang.String val)` Set (or delete) a custom property for a resource.
`void` | `startup()`
`ApplicationValue` | `updateApplication(int sessionId, ApplicationValue app)`
`void` | `updateGroup(int sessionId, ResourceGroup group, java.lang.String name, java.lang.String description, java.lang.String location)` Update properties of a group.
`PlatformValue` | `updatePlatform(AuthzSubject subject, PlatformValue aPlatform)`
`PlatformValue` | `updatePlatform(int sessionId, PlatformValue aPlatform)`
`ServerValue` | `updateServer(int sessionId, ServerValue aServer)`
`ServerValue` | `updateServer(int sessionId, ServerValue aServer, java.util.Map cProps)` Update a server with cprops.
`ServiceValue` | `updateService(AuthzSubject subject, ServiceValue aService, java.util.Map cProps)` Update a service with cProps.
`ServiceValue` | `updateService(int sessionId, ServiceValue aService)`
`ServiceValue` | `updateService(int sessionId, ServiceValue aService, java.util.Map cProps)` Update a service with cProps.

Methods inherited from class org.hyperic.hq.bizapp.server.session.BizappSessionEJB
`getAgentManager, getAIBoss, getAIManager, getAppdefBoss, getAppdefStatManager, getApplicationManager, getAuthManager, getAuthzBoss, getAuthzSubjectManager, getAutoInventoryManager, getAvailManager, getConfigManager, getControlBoss, getControlManager, getControlScheduleManager, getCPropManager, getDataMan, getEventsBoss, getMeasurementBoss, getMetricManager, getOverlord, getPlatformManager, getProductBoss, getProductManager, getReportProcessor, getResourceGroupManager, getResourceManager, getServerConfigManager, getServerManager, getServiceManager, getSessionContext, getSrnManager, getTemplateManager, getTrackerManager, rollback, setSessionContext`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.ejb.SessionBean
`setSessionContext`

Field Detail

### log

    protected org.apache.commons.logging.Log log

### debug

    protected boolean debug

### APPDEF_TYPE_UNDEFINED

    protected final int APPDEF_TYPE_UNDEFINED

See Also:
  Constant Field Values

### APPDEF_RES_TYPE_UNDEFINED

    protected final int APPDEF_RES_TYPE_UNDEFINED

See Also:
  Constant Field Values

### APPDEF_GROUP_TYPE_UNDEFINED

    protected final int APPDEF_GROUP_TYPE_UNDEFINED

See Also:
  Constant Field Values

Constructor Detail

### AppdefBossEJBImpl

    public AppdefBossEJBImpl()

Method Detail

### findCommonResourceType

    public AppdefResourceType findCommonResourceType(int sessionID,
                                                     java.lang.String[] aeids)
                                              throws AppdefEntityNotFoundException,
                                                     PermissionException,
                                                     SessionNotFoundException,
                                                     SessionTimeoutException

  Find a common appdef resource type among the appdef entities

  Parameters:
    `sessionID` -
    `aeids` - the array of appdef entity IDs
  Returns:
    AppdefResourceTypeValue if they are of same type, null otherwise
  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionNotFoundException`
    `SessionTimeoutException`

### findAllPlatformTypes

    public PageList findAllPlatformTypes(int sessionID,
                                         PageControl pc)
                                  throws SessionTimeoutException,
                                         SessionNotFoundException,
                                         PermissionException

  Find all the platform types defined in the system.

  Returns:
    A list of PlatformTypeValue objects.
  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findViewablePlatformTypes

    public PageList findViewablePlatformTypes(int sessionID,
                                              PageControl pc)
                                       throws SessionTimeoutException,
                                              SessionNotFoundException,
                                              PermissionException,
                                              javax.ejb.FinderException

  Find all the viewable platform types defined in the system.

  Returns:
    A list of PlatformTypeValue objects.
  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `javax.ejb.FinderException`

### findAllServerTypes

    public PageList findAllServerTypes(int sessionID,
                                       PageControl pc)
                                throws javax.ejb.FinderException,
                                       SessionNotFoundException,
                                       SessionTimeoutException,
                                       PermissionException

  Find all the server types defined in the system.

  Returns:
    A list of ServerTypeValue objects.
  Throws:
    `javax.ejb.FinderException`
    `SessionNotFoundException`
    `SessionTimeoutException`
    `PermissionException`

### findViewableServerTypes

    public PageList findViewableServerTypes(int sessionID,
                                            PageControl pc)
                                     throws javax.ejb.FinderException,
                                            SessionNotFoundException,
                                            SessionTimeoutException,
                                            PermissionException

  Find all viewable server types defined in the system.

  Returns:
    A list of ServerTypeValue objects.
  Throws:
    `javax.ejb.FinderException`
    `SessionNotFoundException`
    `SessionTimeoutException`
    `PermissionException`

### findAllApplicationTypes

    public java.util.List findAllApplicationTypes(int sessionID)
                                           throws ApplicationException

  Throws:
    `ApplicationException`

### findApplicationTypeById

    public ApplicationType findApplicationTypeById(int sessionId,
                                                   java.lang.Integer id)
                                            throws ApplicationException

  Throws:
    `ApplicationException`

### findAllServiceTypes

    public PageList findAllServiceTypes(int sessionID,
                                        PageControl pc)
                                 throws SessionTimeoutException,
                                        SessionNotFoundException,
                                        PermissionException

  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findViewableServiceTypes

    public PageList findViewableServiceTypes(int sessionID,
                                             PageControl pc)
                                      throws javax.ejb.FinderException,
                                             SessionTimeoutException,
                                             SessionNotFoundException,
                                             PermissionException

  Throws:
    `javax.ejb.FinderException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findViewablePlatformServiceTypes

    public PageList findViewablePlatformServiceTypes(int sessionID,
                                                     java.lang.Integer platId)
                                              throws SessionTimeoutException,
                                                     SessionNotFoundException,
                                                     PermissionException

  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findApplicationById

    public ApplicationValue findApplicationById(int sessionID,
                                                java.lang.Integer id)
                                         throws AppdefEntityNotFoundException,
                                                PermissionException,
                                                SessionTimeoutException,
                                                SessionNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findChildResources

    public PageList findChildResources(int sessionID,
                                       AppdefEntityID parent,
                                       AppdefEntityTypeID childResourceType,
                                       PageControl pc)
                                throws SessionException,
                                       PermissionException,
                                       AppdefEntityNotFoundException

  Get first-level child resources of a given resource based on the child resource type.

  For example:

  - platform - list of servers
  - server - list of services
  - service - not supported
  - application - list of services
  - group - list of members if the group is compatible

  Parameters:
    `parent` - the resource whose children we want
    `childResourceType` - the type of child resource
  Returns:
    list of ``AppdefResourceValue`` objects
  Throws:
    `SessionException`
    `PermissionException`
    `AppdefEntityNotFoundException`

### findApplications

    public PageList findApplications(int sessionID,
                                     AppdefEntityID id,
                                     PageControl pc)
                              throws AppdefEntityNotFoundException,
                                     PermissionException,
                                     SessionTimeoutException,
                                     SessionNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findPlatformServices

    public PageList findPlatformServices(int sessionID,
                                         java.lang.Integer platformId,
                                         PageControl pc)
                                  throws AppdefEntityNotFoundException,
                                         PermissionException,
                                         SessionTimeoutException,
                                         SessionNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findPlatformServices

    public PageList findPlatformServices(int sessionID,
                                         java.lang.Integer platformId,
                                         java.lang.Integer typeId,
                                         PageControl pc)
                                  throws AppdefEntityNotFoundException,
                                         PermissionException,
                                         SessionTimeoutException,
                                         SessionNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findServiceInventoryByApplication

    public PageList findServiceInventoryByApplication(int sessionID,
                                                      java.lang.Integer appId,
                                                      PageControl pc)
                                               throws AppdefEntityNotFoundException,
                                                      SessionException,
                                                      PermissionException

  Find service inventory by application - including services and clusters

  Throws:
    `AppdefEntityNotFoundException`
    `SessionException`
    `PermissionException`

### findServicesByServer

    public PageList findServicesByServer(int sessionID,
                                         java.lang.Integer serverId,
                                         PageControl pc)
                                  throws AppdefEntityNotFoundException,
                                         PermissionException,
                                         SessionException

  Find all services on a server

  Returns:
    A list of ServiceValue objects.
  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionException`

### findPlatformByDependentID

    public PlatformValue findPlatformByDependentID(int sessionID,
                                                   AppdefEntityID entityId)
                                            throws AppdefEntityNotFoundException,
                                                   SessionTimeoutException,
                                                   SessionNotFoundException,
                                                   PermissionException

  Find the platform by service.

  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findServerByService

    public ServerValue findServerByService(int sessionID,
                                           java.lang.Integer serviceID)
                                    throws AppdefEntityNotFoundException,
                                           SessionTimeoutException,
                                           SessionNotFoundException,
                                           PermissionException

  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findServersByTypeAndPlatform

    public PageList findServersByTypeAndPlatform(int sessionId,
                                                 java.lang.Integer platformId,
                                                 int adResTypeId,
                                                 PageControl pc)
                                          throws AppdefEntityNotFoundException,
                                                 PermissionException,
                                                 SessionTimeoutException,
                                                 SessionNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findVirtualServerByPlatformServiceType

    public ServerValue findVirtualServerByPlatformServiceType(int sessionID,
                                                              java.lang.Integer platId,
                                                              java.lang.Integer svcTypeId)
                                                       throws ServerNotFoundException,
                                                              PlatformNotFoundException,
                                                              PermissionException,
                                                              SessionNotFoundException,
                                                              SessionTimeoutException

  Get the virtual server for a given platform and service type

  Throws:
    `ServerNotFoundException`
    `PlatformNotFoundException`
    `PermissionException`
    `SessionNotFoundException`
    `SessionTimeoutException`

### findServersByPlatform

    public PageList findServersByPlatform(int sessionID,
                                          java.lang.Integer platformId,
                                          PageControl pc)
                                   throws AppdefEntityNotFoundException,
                                          SessionTimeoutException,
                                          SessionNotFoundException,
                                          PermissionException

  Find all servers on a given platform

  Returns:
    A list of ServerValue objects
  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findViewableServersByPlatform

    public PageList findViewableServersByPlatform(int sessionID,
                                                  java.lang.Integer platformId,
                                                  PageControl pc)
                                           throws AppdefEntityNotFoundException,
                                                  PermissionException,
                                                  SessionTimeoutException,
                                                  SessionNotFoundException

  Get the virtual servers for a given platform

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findServerTypesByPlatform

    public PageList findServerTypesByPlatform(int sessionID,
                                              java.lang.Integer platformId,
                                              PageControl pc)
                                       throws AppdefEntityNotFoundException,
                                              PermissionException,
                                              SessionTimeoutException,
                                              SessionNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findServerTypesByPlatformType

    public PageList findServerTypesByPlatformType(int sessionID,
                                                  java.lang.Integer platformId,
                                                  PageControl pc)
                                           throws AppdefEntityNotFoundException,
                                                  SessionTimeoutException,
                                                  SessionNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findAllPlatforms

    public PageList findAllPlatforms(int sessionID,
                                     PageControl pc)
                              throws javax.ejb.FinderException,
                                     SessionTimeoutException,
                                     SessionNotFoundException,
                                     PermissionException

  Get all platforms in the inventory.

  Parameters:
    `sessionID` - The current session token.
    `pc` - a PageControl object which determines the size of the page and the sorting, if any.
  Returns:
    A List of PlatformValue objects representing all of the platforms that the given subject is allowed to view.
  Throws:
    `javax.ejb.FinderException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findRecentPlatforms

    public PageList findRecentPlatforms(int sessionID,
                                        long range,
                                        int size)
                                 throws javax.ejb.FinderException,
                                        SessionTimeoutException,
                                        SessionNotFoundException,
                                        PermissionException

  Get recently created platforms in the inventory.

  Parameters:
    `sessionID` - The current session token.
  Returns:
    A List of PlatformValue objects representing all of the platforms that the given subject is allowed to view that was created in the past time range specified.
  Throws:
    `javax.ejb.FinderException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findByIds

    public PageList findByIds(int sessionId,
                              AppdefEntityID[] entities,
                              PageControl pc)
                       throws PermissionException,
                              SessionTimeoutException,
                              SessionNotFoundException

  Looks up and returns a list of value objects corresponding to the list of appdef entity represented by the instance ids passed in. The method does not require the caller to know the instance-id's corresponding type. Similarly, the return value is upcasted.

  Returns:
    list of appdefResourceValue
  Throws:
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findById

    public AppdefResourceValue findById(int sessionId,
                                        AppdefEntityID entityId)
                                 throws AppdefEntityNotFoundException,
                                        PermissionException,
                                        SessionTimeoutException,
                                        SessionNotFoundException

  Looks up and returns a value object corresponding to the appdef entity represented by the instance id passed in. The method does not require the caller to know the instance-id's corresponding type. Similarly, the return value is upcasted.

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findPlatformById

    public PlatformValue findPlatformById(int sessionID,
                                          java.lang.Integer id)
                                   throws AppdefEntityNotFoundException,
                                          SessionTimeoutException,
                                          SessionNotFoundException,
                                          PermissionException

  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findResourceAgent

    public Agent findResourceAgent(AppdefEntityID entityId)
                            throws AppdefEntityNotFoundException,
                                   SessionTimeoutException,
                                   SessionNotFoundException,
                                   PermissionException,
                                   AgentNotFoundException

  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `AgentNotFoundException`

### findServerById

    public ServerValue findServerById(int sessionID,
                                      java.lang.Integer id)
                               throws AppdefEntityNotFoundException,
                                      SessionTimeoutException,
                                      SessionNotFoundException,
                                      PermissionException

  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findServiceById

    public ServiceValue findServiceById(int sessionID,
                                        java.lang.Integer id)
                                 throws AppdefEntityNotFoundException,
                                        SessionTimeoutException,
                                        SessionNotFoundException,
                                        PermissionException

  Throws:
    `AppdefEntityNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findAllResourceTypes

    public PageList findAllResourceTypes(int sessionId,
                                         PageControl pc)
                                  throws SessionTimeoutException,
                                         SessionNotFoundException,
                                         PermissionException

  Returns:
    A PageList of all registered appdef resource types as well as the three group specific resource types.
  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findAllResourceTypes

    public PageList findAllResourceTypes(int sessionId,
                                         int entType,
                                         PageControl pc)
                                  throws SessionTimeoutException,
                                         SessionNotFoundException,
                                         PermissionException

  Returns:
    A PageList of all registered appdef resource types of a particular entity type.
  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### createPlatform

    public Platform createPlatform(int sessionID,
                                   PlatformValue platformVal,
                                   java.lang.Integer platTypePK,
                                   java.lang.Integer agent)
                            throws javax.ejb.CreateException,
                                   ValidationException,
                                   SessionTimeoutException,
                                   SessionNotFoundException,
                                   PermissionException,
                                   AppdefDuplicateNameException,
                                   AppdefDuplicateFQDNException,
                                   ApplicationException

  Parameters:
    `platTypePK` - - the type of platform
  Returns:
    PlatformValue - the saved Value object
  Throws:
    `javax.ejb.CreateException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `AppdefDuplicateNameException`
    `AppdefDuplicateFQDNException`
    `ApplicationException`

### findResourceTypeById

    public AppdefResourceTypeValue findResourceTypeById(int sessionID,
                                                        AppdefEntityTypeID id)
                                                 throws SessionTimeoutException,
                                                        SessionNotFoundException

  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`

### findPlatformTypeById

    public PlatformType findPlatformTypeById(int sessionID,
                                             java.lang.Integer id)
                                      throws PlatformNotFoundException,
                                             SessionTimeoutException,
                                             SessionNotFoundException

  Throws:
    `PlatformNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findPlatformTypeByName

    public PlatformType findPlatformTypeByName(int sessionID,
                                               java.lang.String name)
                                        throws PlatformNotFoundException,
                                               SessionTimeoutException,
                                               SessionNotFoundException

  Throws:
    `PlatformNotFoundException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findServiceTypeById

    public ServiceType findServiceTypeById(int sessionID,
                                           java.lang.Integer id)
                                    throws SessionTimeoutException,
                                           SessionNotFoundException

  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`

### findServiceTypesByServerType

    public PageList findServiceTypesByServerType(int sessionID,
                                                 int serverTypeId)
                                          throws SessionTimeoutException,
                                                 SessionNotFoundException

  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`

### findServerTypeById

    public ServerType findServerTypeById(int sessionID,
                                         java.lang.Integer id)
                                  throws SessionTimeoutException,
                                         SessionNotFoundException

  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`

### createServer

    public ServerValue createServer(int sessionID,
                                    ServerValue serverVal,
                                    java.lang.Integer platformPK,
                                    java.lang.Integer serverTypePK,
                                    java.util.Map cProps)
                             throws javax.ejb.CreateException,
                                    ValidationException,
                                    SessionTimeoutException,
                                    SessionNotFoundException,
                                    PermissionException,
                                    AppdefDuplicateNameException,
                                    CPropKeyNotFoundException

  Create a server with CProps

  Parameters:
    `platformPK` - - the pk of the host platform
    `serverTypePK` - - the type of server
    `cProps` - - the map with Custom Properties for the server
  Returns:
    ServerValue - the saved server
  Throws:
    `javax.ejb.CreateException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `AppdefDuplicateNameException`
    `CPropKeyNotFoundException`

### createApplication

    public ApplicationValue createApplication(int sessionID,
                                              ApplicationValue appVal,
                                              java.util.Collection services,
                                              ConfigResponse protoProps)
                                       throws javax.ejb.CreateException,
                                              ValidationException,
                                              SessionTimeoutException,
                                              SessionNotFoundException,
                                              PermissionException,
                                              AppdefDuplicateNameException

  Create an application

  Returns:
    ApplicationValue - the saved application
  Throws:
    `javax.ejb.CreateException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `AppdefDuplicateNameException`

### createService

    public ServiceValue createService(int sessionID,
                                      ServiceValue serviceVal,
                                      java.lang.Integer serviceTypePK,
                                      AppdefEntityID aeid)
                               throws SessionNotFoundException,
                                      SessionTimeoutException,
                                      ServerNotFoundException,
                                      PlatformNotFoundException,
                                      PermissionException,
                                      AppdefDuplicateNameException,
                                      ValidationException,
                                      javax.ejb.CreateException

  Parameters:
    `serviceTypePK` - - the type of service
    `aeid` - - the appdef entity ID
  Returns:
    ServiceValue - the saved ServiceValue
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `ServerNotFoundException`
    `PlatformNotFoundException`
    `PermissionException`
    `AppdefDuplicateNameException`
    `ValidationException`
    `javax.ejb.CreateException`

### createService

    public Service createService(AuthzSubject subject,
                                 ServiceValue serviceVal,
                                 java.lang.Integer serviceTypePK,
                                 java.lang.Integer serverPK,
                                 java.util.Map cProps)
                          throws SessionNotFoundException,
                                 SessionTimeoutException,
                                 AppdefDuplicateNameException,
                                 ValidationException,
                                 PermissionException,
                                 javax.ejb.CreateException,
                                 CPropKeyNotFoundException

  Create a service with CProps

  Parameters:
    `serviceTypePK` - - the type of service
    `serverPK` - - the server host
    `cProps` - - the map with Custom Properties for the service
  Returns:
    Service - the saved Service
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `AppdefDuplicateNameException`
    `ValidationException`
    `PermissionException`
    `javax.ejb.CreateException`
    `CPropKeyNotFoundException`

### removeAppdefEntity

    public AppdefEntityID[] removeAppdefEntity(int sessionId,
                                               AppdefEntityID aeid)
                                        throws SessionNotFoundException,
                                               SessionTimeoutException,
                                               ApplicationException,
                                               VetoException

  Removes an appdef entity by nulling out any reference from its children and then deleting it synchronously. The children are then cleaned up in the zevent queue by issuing a `ResourcesCleanupZevent`

  Returns:
    AppdefEntityID[] - an array of the resources (including children) deleted
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `ApplicationException`
    `VetoException`

### removeDeletedResources

    public void removeDeletedResources(java.util.Map agentCache)
                                throws ApplicationException,
                                       VetoException,
                                       javax.ejb.RemoveException

  Remove all delete resources Method is "NotSupported" since all the resource deletes may take longer than the jboss transaction timeout. No need for a transaction in this context.

  Parameters:
    `agentCache` - `Map` of `Integer` of agentIds to `List` of `AppdefEntityID`s
  Throws:
    `ApplicationException`
    `VetoException`
    `javax.ejb.RemoveException`

### _removePlatformInNewTran

    public void _removePlatformInNewTran(AuthzSubject subject,
                                         Platform platform)
                                  throws ApplicationException,
                                         VetoException

  Throws:
    `ApplicationException`
    `VetoException`

### removePlatform

    public void removePlatform(AuthzSubject subject,
                               Platform platform)
                        throws ApplicationException,
                               VetoException

  Throws:
    `ApplicationException`
    `VetoException`

### _removeServerInNewTran

    public void _removeServerInNewTran(AuthzSubject subject,
                                       Server server)
                                throws VetoException,
                                       PermissionException

  Used only during the asynchronous delete process.

  Throws:
    `VetoException`
    `PermissionException`

### _removeServiceInNewTran

    public void _removeServiceInNewTran(AuthzSubject subject,
                                        Service service)
                                 throws VetoException,
                                        PermissionException,
                                        javax.ejb.RemoveException

  Used only during the asynchronous delete process.

  Throws:
    `VetoException`
    `PermissionException`
    `javax.ejb.RemoveException`

### _removeGroupInNewTran

    public void _removeGroupInNewTran(AuthzSubject subject,
                                      ResourceGroup group)
                               throws SessionException,
                                      PermissionException,
                                      VetoException

  Throws:
    `SessionException`
    `PermissionException`
    `VetoException`

### _removeApplicationInNewTran

    public void _removeApplicationInNewTran(AuthzSubject subject,
                                            Application app)
                                     throws ApplicationException,
                                            PermissionException,
                                            SessionException,
                                            VetoException

  Throws:
    `ApplicationException`
    `PermissionException`
    `SessionException`
    `VetoException`

### updateServer

    public ServerValue updateServer(int sessionId,
                                    ServerValue aServer)
                             throws PermissionException,
                                    ValidationException,
                                    SessionTimeoutException,
                                    SessionNotFoundException,
                                    javax.ejb.FinderException,
                                    UpdateException,
                                    AppdefDuplicateNameException

  Throws:
    `PermissionException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `javax.ejb.FinderException`
    `UpdateException`
    `AppdefDuplicateNameException`

### updateServer

    public ServerValue updateServer(int sessionId,
                                    ServerValue aServer,
                                    java.util.Map cProps)
                             throws javax.ejb.FinderException,
                                    ValidationException,
                                    SessionTimeoutException,
                                    SessionNotFoundException,
                                    PermissionException,
                                    UpdateException,
                                    AppdefDuplicateNameException,
                                    CPropKeyNotFoundException

  Update a server with cprops.

  Parameters:
    `cProps` - - the map with Custom Properties for the server
  Throws:
    `javax.ejb.FinderException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `UpdateException`
    `AppdefDuplicateNameException`
    `CPropKeyNotFoundException`

### updateService

    public ServiceValue updateService(int sessionId,
                                      ServiceValue aService)
                               throws PermissionException,
                                      ValidationException,
                                      SessionTimeoutException,
                                      SessionNotFoundException,
                                      javax.ejb.FinderException,
                                      UpdateException,
                                      AppdefDuplicateNameException

  Throws:
    `PermissionException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `javax.ejb.FinderException`
    `UpdateException`
    `AppdefDuplicateNameException`

### updateService

    public ServiceValue updateService(int sessionId,
                                      ServiceValue aService,
                                      java.util.Map cProps)
                               throws javax.ejb.FinderException,
                                      ValidationException,
                                      SessionTimeoutException,
                                      SessionNotFoundException,
                                      PermissionException,
                                      UpdateException,
                                      AppdefDuplicateNameException,
                                      CPropKeyNotFoundException

  Update a service with cProps.

  Parameters:
    `cProps` - - the map with Custom Properties for the service
  Throws:
    `javax.ejb.FinderException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `UpdateException`
    `AppdefDuplicateNameException`
    `CPropKeyNotFoundException`

### updateService

    public ServiceValue updateService(AuthzSubject subject,
                                      ServiceValue aService,
                                      java.util.Map cProps)
                               throws javax.ejb.FinderException,
                                      ValidationException,
                                      SessionTimeoutException,
                                      SessionNotFoundException,
                                      PermissionException,
                                      UpdateException,
                                      AppdefDuplicateNameException,
                                      CPropKeyNotFoundException

  Update a service with cProps.

  Parameters:
    `cProps` - - the map with Custom Properties for the service
  Throws:
    `javax.ejb.FinderException`
    `ValidationException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`
    `UpdateException`
    `AppdefDuplicateNameException`
    `CPropKeyNotFoundException`

### updatePlatform

    public PlatformValue updatePlatform(int sessionId,
                                        PlatformValue aPlatform)
                                 throws javax.ejb.FinderException,
                                        ValidationException,
                                        PermissionException,
                                        SessionTimeoutException,
                                        SessionNotFoundException,
                                        UpdateException,
                                        ApplicationException,
                                        AppdefDuplicateNameException,
                                        AppdefDuplicateFQDNException

  Throws:
    `javax.ejb.FinderException`
    `ValidationException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `UpdateException`
    `ApplicationException`
    `AppdefDuplicateNameException`
    `AppdefDuplicateFQDNException`

### updatePlatform

    public PlatformValue updatePlatform(AuthzSubject subject,
                                        PlatformValue aPlatform)
                                 throws javax.ejb.FinderException,
                                        ValidationException,
                                        PermissionException,
                                        SessionTimeoutException,
                                        SessionNotFoundException,
                                        UpdateException,
                                        ApplicationException,
                                        AppdefDuplicateNameException,
                                        AppdefDuplicateFQDNException

  Throws:
    `javax.ejb.FinderException`
    `ValidationException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `UpdateException`
    `ApplicationException`
    `AppdefDuplicateNameException`
    `AppdefDuplicateFQDNException`

### updateApplication

    public ApplicationValue updateApplication(int sessionId,
                                              ApplicationValue app)
                                       throws ApplicationException,
                                              PermissionException

  Throws:
    `ApplicationException`
    `PermissionException`

### setApplicationServices

    public void setApplicationServices(int sessionId,
                                       java.lang.Integer appId,
                                       java.util.List entityIds)
                                throws ApplicationException,
                                       PermissionException

  Set the services used by an application indicate whether the service is an entry point

  Throws:
    `ApplicationException`
    `PermissionException`

### getAppDependencyTree

    public DependencyTree getAppDependencyTree(int sessionId,
                                               java.lang.Integer appId)
                                        throws ApplicationException,
                                               PermissionException

  Get the dependency tree for a given application

  Throws:
    `ApplicationException`
    `PermissionException`

### setAppDependencyTree

    public void setAppDependencyTree(int sessionId,
                                     DependencyTree depTree)
                              throws ApplicationException,
                                     PermissionException

  Throws:
    `ApplicationException`
    `PermissionException`

### removeServer

    public void removeServer(AuthzSubject subj,
                             java.lang.Integer serverId)
                      throws ServerNotFoundException,
                             SessionNotFoundException,
                             SessionTimeoutException,
                             PermissionException,
                             SessionException,
                             VetoException

  Throws:
    `ServerNotFoundException`
    `SessionNotFoundException`
    `SessionTimeoutException`
    `PermissionException`
    `SessionException`
    `VetoException`

### removeAppService

    public void removeAppService(int sessionId,
                                 java.lang.Integer appId,
                                 java.lang.Integer serviceId)
                          throws ApplicationException,
                                 ApplicationNotFoundException,
                                 PermissionException,
                                 SessionTimeoutException,
                                 SessionNotFoundException

  Remove an application service.

  Parameters:
    `appId` - - The application identifier.
  Throws:
    `ApplicationException`
    `ApplicationNotFoundException`
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### changeResourceOwner

    public AppdefResourceValue changeResourceOwner(int sessionId,
                                                   AppdefEntityID eid,
                                                   java.lang.Integer newOwnerId)
                                            throws ApplicationException,
                                                   PermissionException

  Returns:
    The updated Resource
  Throws:
    `ApplicationException`
    `PermissionException`

### createGroup

    public ResourceGroup createGroup(int sessionId,
                                     java.lang.String name,
                                     java.lang.String description,
                                     java.lang.String location,
                                     java.lang.String[] resources,
                                     boolean privGrp)
                              throws GroupCreationException,
                                     GroupDuplicateNameException,
                                     SessionException

  Create and return a new mixed group value object. This group can contain mixed resources of any entity/resource type combination including platform, server and service.

  Parameters:
    `name` - - The name of the group.
    `description` - - A description of the group contents. (optional)
    `location` - - Location of group (optional)
  Returns:
    AppdefGroupValue object
  Throws:
    `GroupCreationException`
    `GroupDuplicateNameException`
    `SessionException`

### createGroup

    public ResourceGroup createGroup(int sessionId,
                                     int adType,
                                     java.lang.String name,
                                     java.lang.String description,
                                     java.lang.String location,
                                     java.lang.String[] resources,
                                     boolean privGrp)
                              throws GroupCreationException,
                                     SessionException,
                                     GroupDuplicateNameException

  Create and return a new strict mixed group value object. This type of group can contain either applications or other groups. However, the choice between between the two is mutually exclusive because all group members must be of the same entity type. Additionally, groups that contain groups are limited to containing either "application groups" or "platform,server&service groups".

  Parameters:
    `adType` - - The appdef entity type (groups or applications)
    `name` - - The name of the group.
    `description` - - A description of the group contents. (optional)
    `location` - - Location of group (optional)
  Returns:
    AppdefGroupValue object
  Throws:
    `GroupCreationException`
    `SessionException`
    `GroupDuplicateNameException`

### createGroup

    public ResourceGroup createGroup(int sessionId,
                                     int adType,
                                     int adResType,
                                     java.lang.String name,
                                     java.lang.String description,
                                     java.lang.String location,
                                     java.lang.String[] resources,
                                     boolean privGrp)
                              throws GroupCreationException,
                                     GroupDuplicateNameException,
                                     SessionException

  Create and return a new compatible group type object. This group type can contain any type of platform, server or service. Compatible groups are strict which means that all members must be of the same type. Compatible group members must also be compatible which means that all group members must have the same resource type. Compatible groups of services have an additional designation of being of type "Cluster".

  Parameters:
    `adType` - - The type of entity this group is compatible with.
    `adResType` - - The resource type this group is compatible with.
    `name` - - The name of the group.
    `description` - - A description of the group contents. (optional)
    `location` - - Location of group (optional)
  Throws:
    `GroupCreationException`
    `GroupDuplicateNameException`
    `SessionException`

### removeResourcesFromGroup

    public void removeResourcesFromGroup(int sessionId,
                                         ResourceGroup group,
                                         java.util.Collection resources)
                                  throws SessionException,
                                         PermissionException,
                                         VetoException

  Remove resources from the group's contents.

  Throws:
    `SessionException`
    `PermissionException`
    `VetoException`

### findGroupById

    public ResourceGroup findGroupById(int sessionId,
                                       java.lang.Integer groupId)
                                throws PermissionException,
                                       SessionException

  Throws:
    `PermissionException`
    `SessionException`

### getResourceTypeCountMap

    public java.util.Map getResourceTypeCountMap(int sessionId,
                                                 java.lang.Integer groupId)
                                          throws PermissionException,
                                                 SessionException

  Throws:
    `PermissionException`
    `SessionException`

### findGroup

    public AppdefGroupValue findGroup(int sessionId,
                                      java.lang.Integer id)
                               throws PermissionException,
                                      SessionException

  Throws:
    `PermissionException`
    `SessionException`

### getGroupsForResource

    public java.util.Collection getGroupsForResource(int sessionId,
                                                     Resource r)
                                              throws SessionNotFoundException,
                                                     SessionTimeoutException

  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`

### findGroups

    public PageList findGroups(int sessionId,
                               java.lang.Integer[] groupIds,
                               PageControl pc)
                        throws PermissionException,
                               SessionException

  Lookup and return a list of group value objects by their identifiers.

  Returns:
    PageList of AppdefGroupValue objects
  Throws:
    `AppdefGroupNotFoundException` - when group cannot be found.
    `InvalidAppdefTypeException` - if group is compat and the appdef type id is incorrect.
    `PermissionException`
    `SessionException`

### findAllGroupsMemberInclusive

    public PageList findAllGroupsMemberInclusive(int sessionId,
                                                 PageControl pc,
                                                 AppdefEntityID entity)
                                          throws PermissionException,
                                                 SessionTimeoutException,
                                                 SessionNotFoundException,
                                                 ApplicationException

  Produce list of all groups where caller is authorized to modify. Include just those groups that contain the specified appdef entity.

  Parameters:
    `entity` - for use in group member filtering.
  Returns:
    List containing AppdefGroupValue.
  Throws:
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`
    `ApplicationException`

### findAllGroupsMemberExclusive

    public PageList findAllGroupsMemberExclusive(int sessionId,
                                                 PageControl pc,
                                                 AppdefEntityID entity)
                                          throws PermissionException,
                                                 SessionTimeoutException,
                                                 SessionNotFoundException

  Produce list of all groups where caller is authorized to modify. Exclude any groups that contain the appdef entity id.

  Parameters:
    `entity` - for use in group member filtering.
  Returns:
    List containing AppdefGroupValue.
  Throws:
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findAllGroupsMemberExclusive

    public PageList findAllGroupsMemberExclusive(int sessionId,
                                                 PageControl pc,
                                                 AppdefEntityID entity,
                                                 java.lang.Integer[] removeIds)
                                          throws PermissionException,
                                                 SessionTimeoutException,
                                                 SessionNotFoundException

  Produce list of all groups where caller is authorized to modify. Exclude any groups that contain the appdef entity id.

  Parameters:
    `entity` - for use in group member filtering.
  Returns:
    List containing AppdefGroupValue.
  Throws:
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findAllGroupsMemberExclusive

    public PageList findAllGroupsMemberExclusive(int sessionId,
                                                 PageControl pc,
                                                 AppdefEntityID entity,
                                                 java.lang.Integer[] removeIds,
                                                 Resource resourceType)
                                          throws PermissionException,
                                                 SessionTimeoutException,
                                                 SessionNotFoundException

  Produce list of all groups where caller is authorized to modify. Exclude any groups that contain the appdef entity id. Filter out any unwanted groups specified by groupId array.

  Parameters:
    `entity` - for use in group member filtering.
  Returns:
    List containing AppdefGroupValue.
  Throws:
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### findAllGroupsMemberExclusive

    public PageList findAllGroupsMemberExclusive(int sessionId,
                                                 PageControl pc,
                                                 AppdefEntityID[] entities)
                                          throws PermissionException,
                                                 SessionException

  Produce list of all groups where caller is authorized to modify. Exclude any groups that contain the appdef entity id. Filter out any unwanted groups specified by groupId array.

  Parameters:
    `entity` - for use in group member filtering.
  Returns:
    List containing AppdefGroupValue.
  Throws:
    `PermissionException`
    `SessionException`

### findAllGroupPojos

    public java.util.Collection findAllGroupPojos(int sessionId)
                                           throws PermissionException,
                                                  SessionTimeoutException,
                                                  SessionNotFoundException

  Produce list of all group pojos where caller is authorized

  Returns:
    List containing AppdefGroup.
  Throws:
    `PermissionException`
    `SessionTimeoutException`
    `SessionNotFoundException`

### addResourcesToGroup

    public void addResourcesToGroup(int sessionID,
                                    ResourceGroup group,
                                    java.util.List aeids)
                             throws SessionException,
                                    PermissionException,
                                    VetoException

  Add entities to a resource group

  Throws:
    `SessionException`
    `PermissionException`
    `VetoException`

### updateGroup

    public void updateGroup(int sessionId,
                            ResourceGroup group,
                            java.lang.String name,
                            java.lang.String description,
                            java.lang.String location)
                     throws SessionException,
                            PermissionException,
                            GroupDuplicateNameException

  Update properties of a group.

  Throws:
    `SessionException`
    `PermissionException`
    `GroupDuplicateNameException`
  See Also:
    `ResourceGroupManagerEJBImpl.updateGroup`

### findCompatInventory

    public PageList findCompatInventory(int sessionId,
                                        int groupType,
                                        int appdefTypeId,
                                        int groupEntTypeId,
                                        int appdefResTypeId,
                                        java.lang.String resourceName,
                                        AppdefEntityID[] pendingEntities,
                                        PageControl pc)
                                 throws AppdefEntityNotFoundException,
                                        PermissionException,
                                        SessionException

  Produce list of compatible, viewable inventory items. The returned list of value objects will consist only of group inventory compatible with the the specified group type. NOTE: This method returns an empty page list when no compatible inventory is found.

  Parameters:
    `groupType` - - the optional group type
    `appdefTypeId` - - the id correponding to the type of entity. example: group, platform, server, service NOTE: A valid entity type id is now MANDATORY!
    `appdefResTypeId` - - the id corresponding to the type of resource example: linux, jboss, vhost
    `resourceName` - - resource name (or name substring) to search for.
  Returns:
    page list of value objects that extend AppdefResourceValue
  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionException`

### findCompatInventory

    public PageList findCompatInventory(int sessionId,
                                        int appdefTypeId,
                                        int appdefResTypeId,
                                        AppdefEntityID groupEntity,
                                        AppdefEntityID[] pendingEntities,
                                        java.lang.String resourceName,
                                        PageControl pc)
                                 throws AppdefEntityNotFoundException,
                                        PermissionException,
                                        SessionException

  Produce list of compatible, viewable inventory items. The returned list of value objects will be filtered on AppdefGroupValue -- if the group contains the entity, then then the entity will not be included in the returned set. NOTE: This method returns an empty page list when no compatible inventory is found.

  Parameters:
    `appdefTypeId` - - the id correponding to the type of entity example: platform, server, service NOTE: A valid entity type id is now MANDATORY!
    `appdefResTypeId` - - the id corresponding to the type of resource example: linux, jboss, vhost
    `groupEntity` - - the appdef entity of a group value who's members are to be filtered out of result set.
    `resourceName` - - resource name (or name substring) to search for.
  Returns:
    page list of value objects that extend AppdefResourceValue
  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionException`

### search

    public PageList search(int sessionId,
                           int appdefTypeId,
                           java.lang.String searchFor,
                           AppdefEntityTypeID appdefResType,
                           java.lang.Integer groupId,
                           int[] groupSubType,
                           boolean matchAny,
                           boolean matchOwn,
                           boolean matchUnavail,
                           PageControl pc)
                    throws PermissionException,
                           SessionException,
                           java.util.regex.PatternSyntaxException

  Perform a search for resources from the resource hub

  Throws:
    `PermissionException`
    `SessionException`
    `java.util.regex.PatternSyntaxException`

### search

    public PageList search(int sessionId,
                           java.lang.String searchFor,
                           PageControl pc)
                    throws SessionTimeoutException,
                           SessionNotFoundException,
                           PermissionException

  Perform a search for resources

  Throws:
    `SessionTimeoutException`
    `SessionNotFoundException`
    `PermissionException`

### findAvailableServicesForApplication

    public PageList findAvailableServicesForApplication(int sessionId,
                                                        java.lang.Integer appId,
                                                        AppdefEntityID[] pendingEntities,
                                                        java.lang.String nameFilter,
                                                        PageControl pc)
                                                 throws AppdefEntityNotFoundException,
                                                        PermissionException,
                                                        SessionException

  Find SERVICE compatible inventory. Specifically, find all viewable services and service clusters. Services that are assigned to clusters are not returned by this method. Value objects returned by this method include ServiceValue and/or AppdefGroupValue. An array of pending AppdefEntityID can also be specified for filtering. NOTE: This method returns an empty page list when no compatible inventory is found.

  Parameters:
    `sessionId` - - valid auth token
  Returns:
    page list of value objects that extend AppdefResourceValue
  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`
    `SessionException`

### batchGroupAdd

    public void batchGroupAdd(int sessionId,
                              AppdefEntityID entityId,
                              java.lang.Integer[] groupIds)
                       throws SessionException,
                              PermissionException,
                              VetoException

  Add an appdef entity to a batch of groups.

  Parameters:
    `sessionId` - representing session identifier
    `entityId` - object to be added.
    `groupIds` - identifier array
  Throws:
    `SessionException`
    `PermissionException`
    `VetoException`

### resetResourceOwnership

    public void resetResourceOwnership(int sessionId,
                                       AuthzSubject currentOwner)
                                throws UpdateException,
                                       PermissionException,
                                       AppdefEntityNotFoundException

  Update all the appdef resources owned by this user to be owned by the root user. This is done to prevent resources from being orphaned in the UI due to its display restrictions. This method should only get called before a user is about to be deleted

  Throws:
    `UpdateException`
    `PermissionException`
    `AppdefEntityNotFoundException`

### batchGroupRemove

    public void batchGroupRemove(int sessionId,
                                 AppdefEntityID entityId,
                                 java.lang.Integer[] groupIds)
                          throws PermissionException,
                                 SessionException,
                                 VetoException

  Remove an appdef entity from a batch of groups.

  Parameters:
    `entityId` - object to be removed
    `groupIds` - identifier array
  Throws:
    `PermissionException`
    `SessionException`
    `VetoException`

### getResourcePermissions

    public AppdefResourcePermissions getResourcePermissions(int sessionId,
                                                            AppdefEntityID id)
                                                     throws SessionNotFoundException,
                                                            SessionTimeoutException,
                                                            javax.ejb.FinderException

  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `javax.ejb.FinderException`

### getAgentCount

    public int getAgentCount(int sessionId)
                      throws SessionNotFoundException,
                             SessionTimeoutException

  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`

### findAllAgents

    public java.util.List findAllAgents(int sessionId)
                                 throws SessionNotFoundException,
                                        SessionTimeoutException

  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`

### findAgentByIpAndPort

    public Agent findAgentByIpAndPort(int sessionId,
                                      java.lang.String ip,
                                      int port)
                               throws SessionNotFoundException,
                                      SessionTimeoutException,
                                      AgentNotFoundException

  Get the value of one agent based on the IP and Port on which the agent is listening

  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `AgentNotFoundException`

### setCPropValue

    public void setCPropValue(int sessionId,
                              AppdefEntityID id,
                              java.lang.String key,
                              java.lang.String val)
                       throws SessionNotFoundException,
                              SessionTimeoutException,
                              AppdefEntityNotFoundException,
                              PermissionException,
                              CPropKeyNotFoundException

  Set (or delete) a custom property for a resource. If the property already exists, it will be overwritten.

  Parameters:
    `id` - Appdef entity to set the value for
    `key` - Key to associate the value with
    `val` - Value to assicate with the key. If the value is null, then the value will simply be removed.
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `AppdefEntityNotFoundException`
    `PermissionException`
    `CPropKeyNotFoundException`

### getCPropDescEntries

    public java.util.Properties getCPropDescEntries(int sessionId,
                                                    AppdefEntityID id)
                                             throws SessionNotFoundException,
                                                    SessionTimeoutException,
                                                    PermissionException,
                                                    AppdefEntityNotFoundException

  Get a map which holds the descriptions & their associated values for an appdef entity.

  Parameters:
    `id` - Appdef entity to get the custom entities for
  Returns:
    The properties stored for a specific entity ID
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `PermissionException`
    `AppdefEntityNotFoundException`

### getCPropKeys

    public java.util.List getCPropKeys(int sessionId,
                                       int appdefType,
                                       int appdefTypeId)
                                throws SessionNotFoundException,
                                       SessionTimeoutException

  Get all the keys associated with an appdef resource type.

  Parameters:
    `appdefType` - One of AppdefEntityConstants.APPDEF_TYPE_*
    `appdefTypeId` - The ID of the appdef resource type
  Returns:
    a List of CPropKeyValue objects
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`

### getCPropKeys

    public java.util.List getCPropKeys(int sessionId,
                                       AppdefEntityID aeid)
                                throws SessionNotFoundException,
                                       SessionTimeoutException,
                                       AppdefEntityNotFoundException,
                                       PermissionException

  Get all the keys associated with an appdef type of a resource.

  Parameters:
    `aeid` - The ID of the appdef resource
  Returns:
    a List of CPropKeyValue objects
  Throws:
    `PermissionException`
    `AppdefEntityNotFoundException`
    `SessionNotFoundException`
    `SessionTimeoutException`

### getInventorySummary

    public AppdefInventorySummary getInventorySummary(int sessionId,
                                                      boolean countTypes)
                                               throws SessionNotFoundException,
                                                      SessionTimeoutException

  Get the appdef inventory summary visible to a user

  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`

### getAppdefTypeStrArrMap

    public java.lang.String[][] getAppdefTypeStrArrMap()

  Returns a 2x2 array mapping "appdef type id" to its corresponding label. Suitable for populating an HTML selector.

### setAllConfigResponses

    public void setAllConfigResponses(int sessionInt,
                                      AllConfigResponses allConfigs,
                                      AllConfigResponses allConfigsRollback)
                               throws PermissionException,
                                      EncodingException,
                                      PluginException,
                                      ApplicationException,
                                      AutoinventoryException,
                                      ScheduleWillNeverFireException,
                                      AgentConnectionException

  A method to set ALL the configs of a resource. This includes the resourceConfig, metricConfig, rtConfig and controlConfig.This also includes the enabling/disabling of rtMetrics for both service and enduser. NOTE: This method should ONLY be called when a user manually configures a resource.

  Parameters:
    `allConfigs` - The full configuation information.
    `allConfigsRollback` - The configuation to rollback to if an error occurs.
  Throws:
    `PermissionException`
    `EncodingException`
    `PluginException`
    `ApplicationException`
    `AutoinventoryException`
    `ScheduleWillNeverFireException`
    `AgentConnectionException`

### getNavMapData

    public ResourceTreeNode[] getNavMapData(int sessionId,
                                            AppdefEntityID adeId)
                                     throws SessionNotFoundException,
                                            SessionTimeoutException,
                                            PermissionException,
                                            AppdefEntityNotFoundException

  Get the navigation map data for a given Appdef entity.

  Returns:
    all navigable resources for the given appdef entity
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `PermissionException`
    `AppdefEntityNotFoundException`

### getNavMapData

    public ResourceTreeNode[] getNavMapData(int sessionId,
                                            AppdefEntityID[] adeIds,
                                            int ctype)
                                     throws SessionNotFoundException,
                                            SessionTimeoutException,
                                            PermissionException,
                                            AppdefEntityNotFoundException

  Get the navigation map data for a an auto-group.

  Parameters:
    `adeIds` - the appdef entity ids of the "parents" of the groupd children
    `ctype` - the child resource type
  Returns:
    all navigable resources for the given appdef entities and child resource type
  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `PermissionException`
    `AppdefEntityNotFoundException`

### getUnavailableResources

    public java.util.Collection getUnavailableResources(AuthzSubject user,
                                                        java.lang.String typeId,
                                                        PageInfo info)
                                                 throws SessionNotFoundException,
                                                        SessionTimeoutException,
                                                        AppdefEntityNotFoundException,
                                                        PermissionException

  Get the list of resources that are unavailable

  Throws:
    `SessionNotFoundException`
    `SessionTimeoutException`
    `AppdefEntityNotFoundException`
    `PermissionException`

### getUnavailableResourcesCount

    public java.util.Map getUnavailableResourcesCount(AuthzSubject user)
                                               throws AppdefEntityNotFoundException,
                                                      PermissionException

  Get the map of unavailable resource counts by type

  Throws:
    `AppdefEntityNotFoundException`
    `PermissionException`

### getServicesView

    public java.util.List getServicesView(AuthzSubject subject,
                                          Resource proto,
                                          java.lang.String cprop,
                                          java.lang.String metricName,
                                          PageInfo pi)
                                   throws PermissionException,
                                          InvalidAppdefTypeException

  Get Service resources and their display information

  Parameters:
    `subject` - the caller
    `proto` - the type name of the services
    `cprop` - a unique custom property name to be fetched
  Throws:
    `PermissionException`
    `InvalidAppdefTypeException`

### hasVirtualResourceRelation

    public boolean hasVirtualResourceRelation(Resource resource)

  Check whether or not a given resource exists in the virtual hierarchy

### startup

    public void startup()

### getOne

    public static org.hyperic.hq.bizapp.shared.AppdefBossLocal getOne()

### ejbCreate

    public void ejbCreate()
                   throws javax.ejb.CreateException

  Throws:
    `javax.ejb.CreateException`

### ejbRemove

    public void ejbRemove()

  Specified by:
    `ejbRemove` in interface `javax.ejb.SessionBean`

### ejbActivate

    public void ejbActivate()

  Specified by:
    `ejbActivate` in interface `javax.ejb.SessionBean`

### ejbPassivate

    public void ejbPassivate()

  Specified by:
    `ejbPassivate` in interface `javax.ejb.SessionBean`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Hyperic HQ Plugin API v. 4.4.0.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004-2006 Hyperic, Inc. support@hyperic.net, All Rights Reserved.